#python

# Written by Rikard Hultman
# www.otakt.com
# www.rikardhultman.com


import lx
import sys
import os
import random
import math


# Snygga till user values
win_depth = lx.eval('user.value rhwmake_window_depth ?')
win_depth = -(win_depth/1000)
win_first_inset = lx.eval('user.value rhwmake_first_inset ?')
win_first_inset = (win_first_inset/1000)
win_second_inset = lx.eval('user.value rhwmake_second_inset ?')
win_second_inset = -(win_second_inset/1000)
win_sprojs_width = lx.eval('user.value win_sprojs_width ?')
win_sprojs_width = (win_sprojs_width/1000)
microbevel = lx.eval('user.value rhwmake_microbevel ?')
microbevel = (microbevel/1000)
window_thickness = lx.eval('user.value rhwmake_window_thickness ?')
window_thickness = -(window_thickness/1000)
sprojsh = lx.eval('user.value rhwmake_subdivs ?')
sprojsv = lx.eval('user.value rhwmake_subdivs_vert ?')
savepolys = lx.eval('user.value rhwmake_save_polys ?')
mode = lx.eval('user.value rhwmake_mode ?')
	
try:

	#####################
	# Quit if no layers are selected
	
	selectedkvar = lx.eval('query layerservice poly.N ? selected')
	if selectedkvar < 1:
		lx.eval('dialog.setup info')
		lx.eval('dialog.msg {Please select some polygons}')
		lx.eval('dialog.open')
		sys.exit()

	# Kopiera valda polygoner s att de kan pasteas i eget lager
	if savepolys == 'Yes':
		lx.eval("select.copy")
	
	
	###################
	# Brja gra fnster
	
	lx.eval("tool.set poly.bevel on")
	lx.eval("tool.reset")
	
	# Fnstrets djup
	lx.eval("tool.setAttr poly.bevel group true")
	lx.eval("tool.setAttr poly.bevel inset "+str(microbevel))
	lx.eval("tool.setAttr poly.bevel shift "+str(-microbevel))
	lx.eval("tool.doApply")
	
	lx.eval("tool.setAttr poly.bevel inset 0")
	lx.eval("tool.setAttr poly.bevel shift "+str(win_depth))
	lx.eval("tool.doApply")
	
	# Karmar
	if mode=='Per selection':
		lx.eval("tool.setAttr poly.bevel group true")
	
	if mode=='Per polygon':
		lx.eval("tool.setAttr poly.bevel group false")
		
	lx.eval("poly.setMaterial {rhwm_Window_frames} {1.0 1.0 1.0} 1.0 0.0 false false")
	lx.eval("select.subitem Material {rhwm_Window_frames}")
		
	lx.eval("tool.setAttr poly.bevel shift 0")
	lx.eval("tool.setAttr poly.bevel inset "+str(win_first_inset))
	lx.eval("tool.doApply")
	


	lx.eval("tool.set poly.bevel off")
	

	if sprojsh > 0 or sprojsv > 0:
		# lx.out('sprosjsjs')
		lx.eval("workPlane.reset")
		lx.eval("workPlane.rotate 1 5.0")
		

		# Lgg till sprjs bara om mode r satt till "polygon"
		if mode=='Per polygon':
			# Kolla om flera polygoner r valda, annars kr alternativ rutin
			if selectedkvar > 1:
				sellayer = lx.eval1('query sceneservice selection ? mesh')
				layerindex = lx.eval('query layerservice layer.index ? %s' % sellayer)
			
				# Kolla vilka polygoner som just nu r valda
				# selectedpolygonsss = list(lx.eval('query layerservice polys ? selected'))
				selectedpolygonsss = lx.eval("query layerservice polys ? selected")

				# Skapa ett temp-set
				lx.eval("select.editSet rhwm_temp add")
				lx.eval("select.editSet rhwm_work add")
				lx.eval("select.drop polygon")

				# Loopa igenom alla valda polygoner och splitta (sprjs)
				for selectedpolygon in selectedpolygonsss:
					# lx.out(selectedpolygon)
					lx.eval("select.useSet rhwm_work select")
					left = lx.eval("query layerservice poly.N ? selected")
					
					# Kolla om det bara r en polygon kvar, annars kr p
					if left == 1:
						temppoly = lx.eval("query layerservice polys ? selected")
					else:		
						tempselpol = list(lx.eval("query layerservice polys ? selected"))
						temppoly = tempselpol[0]

					# lx.out(left)
					# lx.out(type(tempselpol))
					# lx.out(tempselpol)
					lx.eval("select.drop polygon")
				
					# lx.eval('select.typeFrom polygon')
					lx.eval("select.element %s polygon set %s" % (layerindex, temppoly))
					# lx.eval("workPlane.fitSelect")
					lx.eval("tool.set poly.julienne on")
					lx.eval("tool.reset")
					lx.eval("tool.setAttr poly.julienne mode number")
					lx.eval("tool.setAttr poly.julienne numY {%s}" %sprojsh)
					lx.eval("tool.setAttr poly.julienne numX {%s}" %sprojsv)
					lx.eval("tool.doApply")
					lx.eval("select.editSet rhwm_work remove")
					lx.eval("select.drop polygon")
					
					lx.eval("tool.set poly.julienne off")
				

				# Vlj polygonerna igen och ta bort settet
				lx.eval("select.useSet rhwm_temp select")
				lx.eval("select.useSet rhwm_work select")
				lx.eval("select.deleteSet rhwm_temp")
				
				# sys.exit()
			else:
				# lx.eval("workPlane.fitSelect")
				lx.eval("tool.set poly.julienne on")
				lx.eval("tool.reset")
				lx.eval("tool.setAttr poly.julienne mode number")
				lx.eval("tool.setAttr poly.julienne numY {%s}" %sprojsh)
				lx.eval("tool.setAttr poly.julienne numX {%s}" %sprojsv)
				# lx.eval("tool.setAttr poly.julienne numZ {%s}" %sprojsv)
				lx.eval("tool.doApply")
				lx.eval("tool.set poly.julienne off")
			
		
		lx.eval("tool.set poly.bevel on")
		
		lx.eval("tool.setAttr poly.bevel shift 0")
		lx.eval("tool.setAttr poly.bevel inset "+str(win_sprojs_width))
		lx.eval("tool.doApply")	
	
	lx.eval("workPlane.reset")
	# Bevla osv
	lx.eval("tool.set poly.bevel on")
	lx.eval("tool.setAttr poly.bevel shift "+str(-microbevel))
	lx.eval("tool.setAttr poly.bevel inset "+str(microbevel))
	lx.eval("tool.doApply")	


		
	# Glas
	if mode=='Per selection':
		lx.eval("tool.setAttr poly.bevel group true")
	
	if mode=='Per polygon':
		lx.eval("tool.setAttr poly.bevel group false")
		
	lx.eval("tool.setAttr poly.bevel inset 0")
	lx.eval("tool.setAttr poly.bevel shift "+str(win_second_inset))
	lx.eval("tool.doApply")

	lx.eval("poly.setMaterial {rhwm_Glass} {1.0 1.0 1.0} 0.0 0.0 true false")
	lx.eval("select.subitem Material {rhwm_Glass}")
	# lx.eval("item.channel advancedMaterial$tranAmt 0.95")
	# lx.eval("item.channel advancedMaterial$reflAmt 0.8")
	# lx.eval("item.channel advancedMaterial$reflAmt 0.06")
	# lx.eval("item.channel advancedMaterial$reflFres 2.0")
	# lx.eval("item.channel advancedMaterial$reflCol {0.3941 0.4704 0.5234}")
	# lx.eval("item.channel advancedMaterial$specAmt 0.061")
	# lx.eval("item.channel advancedMaterial$specFres 0.995")
	# lx.eval("item.channel advancedMaterial$physical true")

	lx.eval("tool.reset")
	lx.eval("tool.set *.bevel off")

	lx.eval("tool.set Thicken on")
	lx.eval("tool.setAttr poly.smshift thicken true")
	lx.eval("tool.setAttr poly.smshift scale 1.0")
	lx.eval("tool.setAttr poly.smshift shift {%s}" %window_thickness)
	lx.eval("tool.doApply")
	
	lx.eval("tool.reset")
	lx.eval("tool.set Thicken off 0")
	
	main = lx.eval("query sceneservice selection ? mesh")

	if savepolys == 'Yes':
		lx.eval("item.create mesh")
		lx.eval("item.name Original_window_polys mesh")
		lx.eval("select.paste")
		
	lx.eval("select.drop polygon")
	lx.eval("select.drop item")	
	
	lx.eval("select.item {%s}" %main)
	lx.eval("select.type polygon")
	
	# lx.eval("poly.setMaterial {window_glass} {1.0 1.0 1.0} 0.0 0.0 true false")


except:
	None


